﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type Dimensions (Width As Int, Height As Int)
	Dim SmallScreen As Boolean = False , FontSize As Int = 12, ItemHeight As Int = 20, LCARCornerElbow2 As Dimensions , LCARfontheight as Int = 30
	
	LCARCornerElbow2.Initialize
	LCARCornerElbow2.Width = 20
	LCARCornerElbow2.Height = 10
End Sub

Sub IIF(Value As Boolean , IfTrue, IfFalse)
	If Value Then Return IfTrue 
	Return IfFalse
End Sub
Sub LCARfont As Typeface 
	Return Typeface.DEFAULT
End Sub

Sub LimitTextWidth(BG As Canvas, Text As String,  theTypeface As Typeface, TextSize As Int, Width As Int, AppendString As String) As String 
	Dim Temp As Int 
	If Text.Length>0 Then
		Temp = BG.MeasureStringWidth(Text, theTypeface,TextSize)
		If Temp> Width Then
			Do While Temp > Width AND Text.Length>0
				Text= Left(Text, Text.Length-1)
				Temp = BG.MeasureStringWidth(Text & AppendString, theTypeface,TextSize)
			Loop
			Return Text & AppendString
		End If
	End If
	Return Text
End Sub

Sub TextWrap(BG As Canvas, Font As Typeface, TextSize As Int, Text As String, MaxWidth As Int ) As String
	Dim tempstr() As String,Temp As Int , WidthofWord As Int ,WidthofLine As Int , tempstr2 As StringBuilder ,WidthofSpace As Int 
	If TextWidthAtHeight(BG,Font,Text,TextSize) <= MaxWidth Then
		Return Text
	Else
		tempstr2.Initialize
		If Text.Contains(CRLF) Then
			tempstr = Regex.Split(CRLF, Text.Trim)
			For Temp = 0 To tempstr.Length-1
				If tempstr(Temp).Trim.Length>0 Then
					tempstr2.Append( TextWrap(BG, Font, TextSize, tempstr(Temp), MaxWidth))
					If Temp < tempstr.Length-1 Then tempstr2.Append(CRLF)
				End If
			Next
		Else
			tempstr = Regex.Split(" ", Text)'(\b[^\s]+\b)
			WidthofSpace=TextWidthAtHeight(BG,Font, " ", TextSize)
			For Temp = 0 To tempstr.Length-1
				WidthofWord=TextWidthAtHeight(BG,Font, tempstr(Temp), TextSize)
				If WidthofLine + WidthofWord > MaxWidth Then 
					tempstr2.Append (" " & CRLF)
					If WidthofWord>WidthofLine Then
						tempstr2.Append(SplitWord(BG,Font, TextSize, tempstr(Temp),MaxWidth,True) & " " & CRLF)
						WidthofLine=0
					Else
						tempstr2.Append(tempstr(Temp) & " ")
						WidthofLine=WidthofWord + WidthofSpace
					End If
				Else
					tempstr2.Append(tempstr(Temp) & " ")
					WidthofLine=WidthofLine+WidthofWord + WidthofSpace
				End If
			Next
		End If
		Return tempstr2.ToString 
	End If
End Sub
Sub SplitWord(BG As Canvas, Font As Typeface, TextSize As Int, Text As String, MaxWidth As Int, DoAppend As Boolean ) As String
	Dim Temp As Int, tempstr As StringBuilder , WidthofLine As Int ,WidthofChar As Int ,tempstr2 As String ,WidthofDash As Int
	tempstr.Initialize 
	WidthofDash=TextWidthAtHeight(BG,Font,"-",TextSize)
	WidthofLine=WidthofDash
	For Temp = 0 To Text.Length-1
		tempstr2=Mid(Text,Temp,1)
		WidthofChar = TextWidthAtHeight(BG,Font,tempstr2,TextSize)
		If WidthofLine+WidthofChar>MaxWidth Then 
			If DoAppend Then tempstr.Append("- " & CRLF & tempstr2 ) Else tempstr.Append("-")
			WidthofLine=WidthofDash
		Else
			tempstr.Append(tempstr2)
		End If
		WidthofLine=WidthofLine+WidthofChar
	Next
	Return tempstr.ToString 
End Sub

Sub TextHeightAtHeight(BG As Canvas, Font As Typeface, Text As String, theFontSize As Int)As Int 
	Dim tempstr() As String ,Height As Int,Temp As Int, CRLFspace As Int 
	CRLFspace=15
	If Text<>Null Then
		If Text.Contains(CRLF) Then
			tempstr = Regex.Split(CRLF,Text)
			For Temp = 0 To tempstr.Length -1
				Height=Height+BG.MeasureStringHeight(tempstr(Temp),Font,theFontSize)+CRLFspace
			Next
			Return Height-CRLFspace
		Else
			Return BG.MeasureStringHeight(Text,Font,theFontSize)
		End If
	End If
End Sub
Sub TextWidthAtHeight(BG As Canvas,Font As Typeface, Text As String, Height As Int) As Int
	Dim tempstr() As String ,Width As Int,Temp As Int ,temp2 As Int
	If Text<>Null Then
		If Text.Contains(CRLF) Then
			tempstr = Regex.Split(CRLF,Text)
			For Temp = 0 To tempstr.Length -1
				temp2=BG.MeasureStringWidth(tempstr(Temp),Font,Height)
				If temp2>Width Then Width=temp2
			Next
			Return Width
		Else
			Return BG.MeasureStringWidth(Text,Font,Height)
		End If
	End If
End Sub
Sub Len(Text As String) As Int
	Return Text.Length 
End Sub
Sub Left(Text As String, Length As Long)As String 
	If Text.Length>0 AND Length>0 Then
		'If Length>Text.Length Then Length=Text.Length 
		Return Text.SubString2(0, Min(Text.Length,Length))
	End If
	Return ""
End Sub
Sub Right(Text As String, Length As Long) As String
	If Text.Length>0 AND Length>0 Then
		'If Length>Text.Length Then Length=Text.Length 
		Return Text.SubString(Text.Length-Min(Text.Length,Length))
	End If
	Return ""
End Sub
Sub Mid(Text As String, Start As Int, Length As Int) As String 
	If Length>0 AND Start>-1 AND Start< Text.Length Then Return Text.SubString2(Start,Start+Length)
End Sub

Sub SetMargin(Target As Object, Value As Int)
	Dim refl As Reflector, args(4) As Object, types(4) As String
    refl.Target = Target
    args(0) = Value    ' left
    args(1) = Value    ' top
    args(2) = Value    ' right
    args(3) = Value    ' bottom
    types(0) = "java.lang.int"
    types(1) = "java.lang.int"
    types(2) = "java.lang.int"
    types(3) = "java.lang.int"
    refl.RunMethod4("setPadding", args, types)    
End Sub

Sub EmergencyBG As Canvas 
	Dim BMP As Bitmap ,BG As Canvas 
	BMP.InitializeMutable(1,1)
	BG.Initialize2(BMP)
	Return BG
End Sub

Sub DrawRect(BG As Canvas, X As Int, Y As Int, Width As Int, Height As Int, Color As Int, Stroke As Int) As Int 
	If Width >0 AND Height> 0 Then BG.DrawRect(SetRect(X,Y,Width,Height), Color, Stroke=0,Stroke)
	Return Y+Height
End Sub
Sub SetRect(X As Int, Y As Int, Width As Int, Height As Int) As Rect 
	Dim Rect1 As Rect 
	Rect1.Initialize(X,Y,X+Width,Y+Height)
	Return Rect1
End Sub
Sub LCAR_RandomColor As Int
	Return 1
End Sub
Sub GetColor(ColorID As Int, State As Boolean, Alpha As Int) As Int 
	Return Colors.Black 
End Sub
Sub GetColor2(ColorID As Int, State As Boolean) As Int 
	Return Colors.Black 
End Sub